"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var https = __importStar(require("https"));
var querystring = __importStar(require("querystring"));
var md5_1 = __importDefault(require("md5"));
var private_1 = require("./private");
var errorMap = {
    52003: '用户认证失败',
    54001: '签名失败',
    54004: '账户余额不足',
};
exports.translate = function (word) {
    var salt = Math.random();
    var sign = md5_1.default(private_1.appid + word + salt + private_1.appSecret);
    var from;
    var to;
    if (/[a-zA-Z]/.test(word[0])) {
        // 英译为中
        from = 'en';
        to = 'zh';
    }
    else {
        from = 'zh';
        to = 'en';
    }
    var query = querystring.stringify({
        q: word,
        from: from,
        to: to,
        appid: private_1.appid,
        salt: salt,
        sign: sign,
    });
    var options = {
        hostname: 'api.fanyi.baidu.com',
        port: 443,
        path: "/api/trans/vip/translate?" + query,
        method: 'GET'
    };
    var request = https.request(options, function (response) {
        var chunks = [];
        response.on('data', function (chunk) {
            chunks.push(chunk);
        });
        response.on('end', function (e) {
            var string = Buffer.concat(chunks).toString();
            var object = JSON.parse(string);
            if (object.error_code) {
                console.error(errorMap[object.error_msg] || object.error_msg);
                process.exit(2);
            }
            else {
                object.trans_result.forEach(function (o) {
                    console.log(o.dst);
                });
                process.exit(0);
            }
        });
    });
    request.on('error', function (e) {
        console.log(e);
    });
    request.end();
};
